#ifndef EFL_GENERATED_EVAS_SMART_CLIPPED_HH
#define EFL_GENERATED_EVAS_SMART_CLIPPED_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_smart_clipped.eo.h"
}

#include "evas_object_smart.eo.hh"
#include <canvas/evas_object.eo.hh>

namespace evas {

struct smart_clipped
      : evas::object_smart
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit smart_clipped(Eo* eo)
      : evas::object_smart(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit smart_clipped(std::nullptr_t)
      : evas::object_smart(nullptr)
   {}

   /// @brief Call the object's constructor.
   /// Should not be used with #eo_do. Only use it with #eo_do_super.
   ///
   smart_clipped(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : smart_clipped(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   smart_clipped(smart_clipped const& other)
      : evas::object_smart(eo_ref(other._eo_ptr()))
   {}

   ~smart_clipped() {}

   /// @brief No description supplied by the EAPI.
   ///
   void hide() const
   {
      eo_do(_eo_ptr(), ::evas_obj_smart_hide());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param clip 
   ///
   void clip_set(evas::object clip_) const
   {
      eo_do(_eo_ptr(), ::evas_obj_smart_clip_set(efl::eolian::to_c(clip_)));
   }

   /// @brief No description supplied by the EAPI.
   ///
   void clip_unset() const
   {
      eo_do(_eo_ptr(), ::evas_obj_smart_clip_unset());
   }

   /// @brief No description supplied by the EAPI.
   ///
   void show() const
   {
      eo_do(_eo_ptr(), ::evas_obj_smart_show());
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param r 
   /// @param g 
   /// @param b 
   /// @param a 
   ///
   void color_set(int r_, int g_, int b_, int a_) const
   {
      eo_do(_eo_ptr(), ::evas_obj_smart_color_set(r_, g_, b_, a_));
   }

   /// @brief No description supplied by the EAPI.
   ///
   /// @param x 
   /// @param y 
   ///
   void move(Evas_Coord x_, Evas_Coord y_) const
   {
      eo_do(_eo_ptr(), ::evas_obj_smart_move(x_, y_));
   }

   /// @brief Removes a member object from a given smart object.
   ///
   /// This removes a member object from a smart object, if it was added
   /// to any. The object will still be on the canvas, but no longer
   /// associated with whichever smart object it was associated with.
   ///
   /// @see evas_object_smart_member_add() for more details
   /// @see evas_object_smart_members_get()
   ///
   /// @param sub_obj the member object
   /// @ingroup Evas_Smart_Object_Group
   ///
   void member_del(evas::object sub_obj_) const
   {
      eo_do(_eo_ptr(), ::evas_obj_smart_member_del(efl::eolian::to_c(sub_obj_)));
   }

   /// @brief Instantiates a new smart object described by @p s.
   ///
   /// @return a new #Evas_Object handle
   ///
   /// This is the function one should use when defining the public
   /// function @b adding an instance of the new smart object to a given
   /// canvas. It will take care of setting all of its internals to work
   /// as they should, if the user set things properly, as seem on the
   /// #EVAS_SMART_SUBCLASS_NEW, for example.
   ///
   /// @ingroup Evas_Smart_Object_Group
   ///
   void add() const
   {
      eo_do(_eo_ptr(), ::evas_obj_smart_add());
   }

   /// @brief Deletes a smart object.
   ///
   void del() const
   {
      eo_do(_eo_ptr(), ::evas_obj_smart_del());
   }

   /// @brief Set an Evas object as a member of a given smart object.
   ///
   /// Members will automatically be stacked and layered together with the
   /// smart object. The various stacking functions will operate on
   /// members relative to the other members instead of the entire canvas,
   /// since they now live on an exclusive layer (see
   /// evas_object_stack_above(), for more details).
   ///
   /// Any @p smart_obj object's specific implementation of the @c
   /// member_add() smart function will take place too, naturally.
   ///
   /// @see evas_object_smart_member_del()
   /// @see evas_object_smart_members_get()
   ///
   /// @ingroup Evas_Smart_Object_Group
   ///
   /// @param sub_obj The member object
   ///
   void member_add(evas::object sub_obj_) const
   {
      eo_do(_eo_ptr(), ::evas_obj_smart_member_add(efl::eolian::to_c(sub_obj_)));
   }

   static Eo_Class const* _eo_class()
   {
      return(EVAS_SMART_CLIPPED_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_ref(EVAS_SMART_CLIPPED_CLASS, _p._eo_raw, eo_constructor());
   }

};
} 

template <typename T>
void evas_smart_clipped_hide_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->hide();
}

template <typename T>
void evas_smart_clipped_clip_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * clip_)
{
   static_cast<T*>(self->this_)->clip_set(efl::eolian::to_cxx<evas::object>(clip_, std::tuple<std::false_type>()));
}

template <typename T>
void evas_smart_clipped_clip_unset_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->clip_unset();
}

template <typename T>
void evas_smart_clipped_show_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->show();
}

template <typename T>
void evas_smart_clipped_color_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int r_, int g_, int b_, int a_)
{
   static_cast<T*>(self->this_)->color_set(r_, g_, b_, a_);
}

template <typename T>
void evas_smart_clipped_move_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Coord x_, Evas_Coord y_)
{
   static_cast<T*>(self->this_)->move(x_, y_);
}

template <typename T>
void evas_smart_clipped_member_del_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * sub_obj_)
{
   static_cast<T*>(self->this_)->member_del(efl::eolian::to_cxx<evas::object>(sub_obj_, std::tuple<std::false_type>()));
}

template <typename T>
void evas_smart_clipped_add_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->add();
}

template <typename T>
void evas_smart_clipped_del_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   static_cast<T*>(self->this_)->del();
}

template <typename T>
void evas_smart_clipped_member_add_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Evas_Object * sub_obj_)
{
   static_cast<T*>(self->this_)->member_add(efl::eolian::to_cxx<evas::object>(sub_obj_, std::tuple<std::false_type>()));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< evas::smart_clipped >
{
   template <typename T>
   struct type
   {
      virtual void hide()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_obj_smart_hide());
      }

      virtual void clip_set(evas::object clip_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_obj_smart_clip_set(efl::eolian::to_c(clip_)));
      }

      virtual void clip_unset()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_obj_smart_clip_unset());
      }

      virtual void show()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_obj_smart_show());
      }

      virtual void color_set(int r_, int g_, int b_, int a_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_obj_smart_color_set(r_, g_, b_, a_));
      }

      virtual void move(Evas_Coord x_, Evas_Coord y_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_obj_smart_move(x_, y_));
      }

      virtual void member_del(evas::object sub_obj_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_obj_smart_member_del(efl::eolian::to_c(sub_obj_)));
      }

      virtual void add()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_obj_smart_add());
      }

      virtual void del()
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_obj_smart_del());
      }

      virtual void member_add(evas::object sub_obj_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::evas_obj_smart_member_add(efl::eolian::to_c(sub_obj_)));
      }

   };
};


template<>
struct operation_description_class_size< evas::smart_clipped >
{
   static const int value = 10;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<evas::smart_clipped>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::evas_smart_clipped_hide_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::evas_obj_smart_hide);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::evas_smart_clipped_clip_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::evas_obj_smart_clip_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::evas_smart_clipped_clip_unset_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::evas_obj_smart_clip_unset);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::evas_smart_clipped_show_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::evas_obj_smart_show);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::evas_smart_clipped_color_set_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::evas_obj_smart_color_set);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::evas_smart_clipped_move_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::evas_obj_smart_move);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::evas_smart_clipped_member_del_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::evas_obj_smart_member_del);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::evas_smart_clipped_add_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::evas_obj_smart_add);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::evas_smart_clipped_del_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::evas_obj_smart_del);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::evas_smart_clipped_member_add_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::evas_obj_smart_member_add);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< evas::smart_clipped >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<evas::smart_clipped, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< evas::smart_clipped >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<evas::smart_clipped, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< evas::smart_clipped>
{
   template <typename U>
   struct type
   {
      operator evas::smart_clipped() const
      {
         return evas::smart_clipped(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void hide()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_obj_smart_hide());
      }

      void clip_set(evas::object clip_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_obj_smart_clip_set(efl::eolian::to_c(clip_)));
      }

      void clip_unset()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_obj_smart_clip_unset());
      }

      void show()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_obj_smart_show());
      }

      void color_set(int r_, int g_, int b_, int a_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_obj_smart_color_set(r_, g_, b_, a_));
      }

      void move(Evas_Coord x_, Evas_Coord y_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_obj_smart_move(x_, y_));
      }

      void member_del(evas::object sub_obj_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_obj_smart_member_del(efl::eolian::to_c(sub_obj_)));
      }

      void add()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_obj_smart_add());
      }

      void del()
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_obj_smart_del());
      }

      void member_add(evas::object sub_obj_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::evas_obj_smart_member_add(efl::eolian::to_c(sub_obj_)));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<evas::smart_clipped>)
{
   return (EVAS_SMART_CLIPPED_CLASS);
}

} } }
#endif // EFL_GENERATED_EVAS_SMART_CLIPPED_HH

